#include <stdio.h>
#include <string.h>
#include "fila.h"

//cdigo associado  posio no vetor
typedef struct {
  char nome[20];
  char autor[20];
  int usuario;//-1 se estiver disponvel na biblioteca
} Livro;

//cdigo associado  posio no vetor
typedef struct{
  char nome[20];
  char tipo[20];
} Usuario;

int main(void) {
    int erro, nlivros=0, nusuarios=0, codlivro, codusuario, i;
    Livro livros[30];
    Usuario usuarios[50];
    Fila reservas[30];
    char opcao[3];

    for (i=0;i<30;i++) Create(&reservas[i]);

    do{
      scanf("%s",opcao);
      if(!strcmp(opcao,"IU")){//insere usurio: IU <nome> <tipo> (sem espacos)
        scanf("%s %s",usuarios[nusuarios].nome,usuarios[nusuarios].tipo);
        nusuarios++;
      }
      else if(!strcmp(opcao,"IL")){//insere livro: IL <nome> <autor> (sem espacos)
        scanf("%s %s",livros[nlivros].nome,livros[nlivros].autor); 
        livros[nlivros].usuario=-1;                                   
        nlivros++;
      }
      else if(!strcmp(opcao,"EL")){//empresta livro: EL <cod livro> <cod usuario>
        scanf("%d %d",&codlivro,&codusuario);
        livros[codlivro].usuario=codusuario;
      }
      else if(!strcmp(opcao,"DL")){//devolve livro: DL <cod livro>
        scanf("%d",&codlivro);
        livros[codlivro].usuario=-1;
      }
      else if(!strcmp(opcao,"RL")){//reserva livro: RL <cod livro> <cod usuario>
        scanf("%d %d",&codlivro,&codusuario);
        Entra(&reservas[codlivro],&codusuario,&erro);
      }
      else if(!strcmp(opcao,"PR")){//prximo na reserva: ER <cod livro>
        scanf("%d",&codlivro);
        Sai(&reservas[codlivro],&codusuario,&erro);
        printf("Proximo na fila: %d\n",codusuario);
      }
      else if(!strcmp(opcao,"CL")){//consulta livros: CL
        for (codlivro=0;codlivro<nlivros;codlivro++){
          printf("Codigo: %d\nNome: %s\nAutor: %s\nEmprestado: %d\nReservas: ",codlivro,livros[codlivro].nome,livros[codlivro].autor,livros[codlivro].usuario);
          Imprime(&reservas[codlivro]);
          printf("\n\n");
        }
      }
    }while(strcmp(opcao,"FE"));//finaliza execuo: FE

    system("pause");
    return 0;
}
